<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAsortiMiktar ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAsortiMiktar
 * @subpackage Arrays
 */
class ArrayOfAsortiMiktar extends AbstractStructArrayBase
{
    /**
     * The AsortiMiktar
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AsortiMiktar[]
     */
    public $AsortiMiktar;
    /**
     * Constructor method for ArrayOfAsortiMiktar
     * @uses ArrayOfAsortiMiktar::setAsortiMiktar()
     * @param \StructType\AsortiMiktar[] $asortiMiktar
     */
    public function __construct(array $asortiMiktar = array())
    {
        $this
            ->setAsortiMiktar($asortiMiktar);
    }
    /**
     * Get AsortiMiktar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AsortiMiktar[]|null
     */
    public function getAsortiMiktar()
    {
        return isset($this->AsortiMiktar) ? $this->AsortiMiktar : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAsortiMiktar method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAsortiMiktar method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAsortiMiktarForArrayConstraintsFromSetAsortiMiktar(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAsortiMiktarAsortiMiktarItem) {
            // validation for constraint: itemType
            if (!$arrayOfAsortiMiktarAsortiMiktarItem instanceof \StructType\AsortiMiktar) {
                $invalidValues[] = is_object($arrayOfAsortiMiktarAsortiMiktarItem) ? get_class($arrayOfAsortiMiktarAsortiMiktarItem) : sprintf('%s(%s)', gettype($arrayOfAsortiMiktarAsortiMiktarItem), var_export($arrayOfAsortiMiktarAsortiMiktarItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AsortiMiktar property can only contain items of type \StructType\AsortiMiktar, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AsortiMiktar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AsortiMiktar[] $asortiMiktar
     * @return \ArrayType\ArrayOfAsortiMiktar
     */
    public function setAsortiMiktar(array $asortiMiktar = array())
    {
        // validation for constraint: array
        if ('' !== ($asortiMiktarArrayErrorMessage = self::validateAsortiMiktarForArrayConstraintsFromSetAsortiMiktar($asortiMiktar))) {
            throw new \InvalidArgumentException($asortiMiktarArrayErrorMessage, __LINE__);
        }
        if (is_null($asortiMiktar) || (is_array($asortiMiktar) && empty($asortiMiktar))) {
            unset($this->AsortiMiktar);
        } else {
            $this->AsortiMiktar = $asortiMiktar;
        }
        return $this;
    }
    /**
     * Add item to AsortiMiktar value
     * @throws \InvalidArgumentException
     * @param \StructType\AsortiMiktar $item
     * @return \ArrayType\ArrayOfAsortiMiktar
     */
    public function addToAsortiMiktar(\StructType\AsortiMiktar $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AsortiMiktar) {
            throw new \InvalidArgumentException(sprintf('The AsortiMiktar property can only contain items of type \StructType\AsortiMiktar, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AsortiMiktar[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AsortiMiktar|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AsortiMiktar|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AsortiMiktar|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AsortiMiktar|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AsortiMiktar|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AsortiMiktar
     */
    public function getAttributeName()
    {
        return 'AsortiMiktar';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAsortiMiktar
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
