<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunKarti ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunKarti
 * @subpackage Arrays
 */
class ArrayOfUrunKarti extends AbstractStructArrayBase
{
    /**
     * The UrunKarti
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunKarti[]
     */
    public $UrunKarti;
    /**
     * Constructor method for ArrayOfUrunKarti
     * @uses ArrayOfUrunKarti::setUrunKarti()
     * @param \StructType\UrunKarti[] $urunKarti
     */
    public function __construct(array $urunKarti = array())
    {
        $this
            ->setUrunKarti($urunKarti);
    }
    /**
     * Get UrunKarti value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunKarti[]|null
     */
    public function getUrunKarti()
    {
        return isset($this->UrunKarti) ? $this->UrunKarti : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunKarti method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunKarti method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunKartiForArrayConstraintsFromSetUrunKarti(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunKartiUrunKartiItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunKartiUrunKartiItem instanceof \StructType\UrunKarti) {
                $invalidValues[] = is_object($arrayOfUrunKartiUrunKartiItem) ? get_class($arrayOfUrunKartiUrunKartiItem) : sprintf('%s(%s)', gettype($arrayOfUrunKartiUrunKartiItem), var_export($arrayOfUrunKartiUrunKartiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunKarti property can only contain items of type \StructType\UrunKarti, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunKarti value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunKarti[] $urunKarti
     * @return \ArrayType\ArrayOfUrunKarti
     */
    public function setUrunKarti(array $urunKarti = array())
    {
        // validation for constraint: array
        if ('' !== ($urunKartiArrayErrorMessage = self::validateUrunKartiForArrayConstraintsFromSetUrunKarti($urunKarti))) {
            throw new \InvalidArgumentException($urunKartiArrayErrorMessage, __LINE__);
        }
        if (is_null($urunKarti) || (is_array($urunKarti) && empty($urunKarti))) {
            unset($this->UrunKarti);
        } else {
            $this->UrunKarti = $urunKarti;
        }
        return $this;
    }
    /**
     * Add item to UrunKarti value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunKarti $item
     * @return \ArrayType\ArrayOfUrunKarti
     */
    public function addToUrunKarti(\StructType\UrunKarti $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunKarti) {
            throw new \InvalidArgumentException(sprintf('The UrunKarti property can only contain items of type \StructType\UrunKarti, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunKarti[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunKarti|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunKarti|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunKarti|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunKarti|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunKarti|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunKarti
     */
    public function getAttributeName()
    {
        return 'UrunKarti';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUrunKarti
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
