<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveKategoriParent StructType
 * @subpackage Structs
 */
class SaveKategoriParent extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The KategoriID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $KategoriID;
    /**
     * The ParentID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ParentID;
    /**
     * Constructor method for SaveKategoriParent
     * @uses SaveKategoriParent::setUyeKodu()
     * @uses SaveKategoriParent::setKategoriID()
     * @uses SaveKategoriParent::setParentID()
     * @param string $uyeKodu
     * @param int $kategoriID
     * @param int $parentID
     */
    public function __construct($uyeKodu = null, $kategoriID = null, $parentID = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setKategoriID($kategoriID)
            ->setParentID($parentID);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveKategoriParent
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get KategoriID value
     * @return int|null
     */
    public function getKategoriID()
    {
        return $this->KategoriID;
    }
    /**
     * Set KategoriID value
     * @param int $kategoriID
     * @return \StructType\SaveKategoriParent
     */
    public function setKategoriID($kategoriID = null)
    {
        // validation for constraint: int
        if (!is_null($kategoriID) && !(is_int($kategoriID) || ctype_digit($kategoriID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kategoriID, true), gettype($kategoriID)), __LINE__);
        }
        $this->KategoriID = $kategoriID;
        return $this;
    }
    /**
     * Get ParentID value
     * @return int|null
     */
    public function getParentID()
    {
        return $this->ParentID;
    }
    /**
     * Set ParentID value
     * @param int $parentID
     * @return \StructType\SaveKategoriParent
     */
    public function setParentID($parentID = null)
    {
        // validation for constraint: int
        if (!is_null($parentID) && !(is_int($parentID) || ctype_digit($parentID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($parentID, true), gettype($parentID)), __LINE__);
        }
        $this->ParentID = $parentID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveKategoriParent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
