<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveResim StructType
 * @subpackage Structs
 */
class SaveResim extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The kartlar
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunKarti
     */
    public $kartlar;
    /**
     * The alanAdi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $alanAdi;
    /**
     * The userAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $userAgent;
    /**
     * Constructor method for SaveResim
     * @uses SaveResim::setUyeKodu()
     * @uses SaveResim::setKartlar()
     * @uses SaveResim::setAlanAdi()
     * @uses SaveResim::setUserAgent()
     * @param string $uyeKodu
     * @param \ArrayType\ArrayOfUrunKarti $kartlar
     * @param string $alanAdi
     * @param string $userAgent
     */
    public function __construct($uyeKodu = null, \ArrayType\ArrayOfUrunKarti $kartlar = null, $alanAdi = null, $userAgent = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setKartlar($kartlar)
            ->setAlanAdi($alanAdi)
            ->setUserAgent($userAgent);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveResim
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get kartlar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunKarti|null
     */
    public function getKartlar()
    {
        return isset($this->kartlar) ? $this->kartlar : null;
    }
    /**
     * Set kartlar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunKarti $kartlar
     * @return \StructType\SaveResim
     */
    public function setKartlar(\ArrayType\ArrayOfUrunKarti $kartlar = null)
    {
        if (is_null($kartlar) || (is_array($kartlar) && empty($kartlar))) {
            unset($this->kartlar);
        } else {
            $this->kartlar = $kartlar;
        }
        return $this;
    }
    /**
     * Get alanAdi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlanAdi()
    {
        return isset($this->alanAdi) ? $this->alanAdi : null;
    }
    /**
     * Set alanAdi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alanAdi
     * @return \StructType\SaveResim
     */
    public function setAlanAdi($alanAdi = null)
    {
        // validation for constraint: string
        if (!is_null($alanAdi) && !is_string($alanAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alanAdi, true), gettype($alanAdi)), __LINE__);
        }
        if (is_null($alanAdi) || (is_array($alanAdi) && empty($alanAdi))) {
            unset($this->alanAdi);
        } else {
            $this->alanAdi = $alanAdi;
        }
        return $this;
    }
    /**
     * Get userAgent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserAgent()
    {
        return isset($this->userAgent) ? $this->userAgent : null;
    }
    /**
     * Set userAgent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userAgent
     * @return \StructType\SaveResim
     */
    public function setUserAgent($userAgent = null)
    {
        // validation for constraint: string
        if (!is_null($userAgent) && !is_string($userAgent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userAgent, true), gettype($userAgent)), __LINE__);
        }
        if (is_null($userAgent) || (is_array($userAgent) && empty($userAgent))) {
            unset($this->userAgent);
        } else {
            $this->userAgent = $userAgent;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveResim
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
