<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveUrunResponse StructType
 * @subpackage Structs
 */
class SaveUrunResponse extends AbstractStructBase
{
    /**
     * The SaveUrunResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SaveUrunResult;
    /**
     * The urunKartlari
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunKarti
     */
    public $urunKartlari;
    /**
     * Constructor method for SaveUrunResponse
     * @uses SaveUrunResponse::setSaveUrunResult()
     * @uses SaveUrunResponse::setUrunKartlari()
     * @param int $saveUrunResult
     * @param \ArrayType\ArrayOfUrunKarti $urunKartlari
     */
    public function __construct($saveUrunResult = null, \ArrayType\ArrayOfUrunKarti $urunKartlari = null)
    {
        $this
            ->setSaveUrunResult($saveUrunResult)
            ->setUrunKartlari($urunKartlari);
    }
    /**
     * Get SaveUrunResult value
     * @return int|null
     */
    public function getSaveUrunResult()
    {
        return $this->SaveUrunResult;
    }
    /**
     * Set SaveUrunResult value
     * @param int $saveUrunResult
     * @return \StructType\SaveUrunResponse
     */
    public function setSaveUrunResult($saveUrunResult = null)
    {
        // validation for constraint: int
        if (!is_null($saveUrunResult) && !(is_int($saveUrunResult) || ctype_digit($saveUrunResult))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saveUrunResult, true), gettype($saveUrunResult)), __LINE__);
        }
        $this->SaveUrunResult = $saveUrunResult;
        return $this;
    }
    /**
     * Get urunKartlari value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunKarti|null
     */
    public function getUrunKartlari()
    {
        return isset($this->urunKartlari) ? $this->urunKartlari : null;
    }
    /**
     * Set urunKartlari value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunKarti $urunKartlari
     * @return \StructType\SaveUrunResponse
     */
    public function setUrunKartlari(\ArrayType\ArrayOfUrunKarti $urunKartlari = null)
    {
        if (is_null($urunKartlari) || (is_array($urunKartlari) && empty($urunKartlari))) {
            unset($this->urunKartlari);
        } else {
            $this->urunKartlari = $urunKartlari;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveUrunResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
