<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UrunOdemeSecenek StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UrunOdemeSecenek
 * @subpackage Structs
 */
class UrunOdemeSecenek extends AbstractStructBase
{
    /**
     * The BankaAdi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BankaAdi;
    /**
     * The BankaID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $BankaID;
    /**
     * The Taksitler
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunOdemeSecenekTaksit
     */
    public $Taksitler;
    /**
     * Constructor method for UrunOdemeSecenek
     * @uses UrunOdemeSecenek::setBankaAdi()
     * @uses UrunOdemeSecenek::setBankaID()
     * @uses UrunOdemeSecenek::setTaksitler()
     * @param string $bankaAdi
     * @param int $bankaID
     * @param \ArrayType\ArrayOfUrunOdemeSecenekTaksit $taksitler
     */
    public function __construct($bankaAdi = null, $bankaID = null, \ArrayType\ArrayOfUrunOdemeSecenekTaksit $taksitler = null)
    {
        $this
            ->setBankaAdi($bankaAdi)
            ->setBankaID($bankaID)
            ->setTaksitler($taksitler);
    }
    /**
     * Get BankaAdi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBankaAdi()
    {
        return isset($this->BankaAdi) ? $this->BankaAdi : null;
    }
    /**
     * Set BankaAdi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bankaAdi
     * @return \StructType\UrunOdemeSecenek
     */
    public function setBankaAdi($bankaAdi = null)
    {
        // validation for constraint: string
        if (!is_null($bankaAdi) && !is_string($bankaAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bankaAdi, true), gettype($bankaAdi)), __LINE__);
        }
        if (is_null($bankaAdi) || (is_array($bankaAdi) && empty($bankaAdi))) {
            unset($this->BankaAdi);
        } else {
            $this->BankaAdi = $bankaAdi;
        }
        return $this;
    }
    /**
     * Get BankaID value
     * @return int|null
     */
    public function getBankaID()
    {
        return $this->BankaID;
    }
    /**
     * Set BankaID value
     * @param int $bankaID
     * @return \StructType\UrunOdemeSecenek
     */
    public function setBankaID($bankaID = null)
    {
        // validation for constraint: int
        if (!is_null($bankaID) && !(is_int($bankaID) || ctype_digit($bankaID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bankaID, true), gettype($bankaID)), __LINE__);
        }
        $this->BankaID = $bankaID;
        return $this;
    }
    /**
     * Get Taksitler value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunOdemeSecenekTaksit|null
     */
    public function getTaksitler()
    {
        return isset($this->Taksitler) ? $this->Taksitler : null;
    }
    /**
     * Set Taksitler value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunOdemeSecenekTaksit $taksitler
     * @return \StructType\UrunOdemeSecenek
     */
    public function setTaksitler(\ArrayType\ArrayOfUrunOdemeSecenekTaksit $taksitler = null)
    {
        if (is_null($taksitler) || (is_array($taksitler) && empty($taksitler))) {
            unset($this->Taksitler);
        } else {
            $this->Taksitler = $taksitler;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UrunOdemeSecenek
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
